#include "mystdio.h"

MYFILE *myfopen(const char *filename, const char *mode)
{

  MYFILE *stream;
  struct stat st;

  stream = (struct _MYFILE *) malloc(sizeof(MYFILE));

  /* MODE D'ACCEE */
  switch (*mode)
    {
    case 'r' :
      stream->mode = 'r';
      stream->flag = O_RDONLY;
      break;
    case 'w' :
      stream->mode = 'w';
      stream->flag = O_WRONLY|O_CREAT|O_TRUNC;
      break;
    case 'a' :
      stream->mode = 'a';
      stream->flag = O_RDWR|O_CREAT;
      break;
    default :
      fprintf(stderr,"Option non Supportee !!!\n");
      exit(-1);
    }
  /* OVERTURE DU FICHIER */
  stream->desc = open(filename,stream->flag);

  if (stream->desc == -1)
    {
      fprintf(stderr,"Impossible d'ouvrir le fichier '%s' \n",filename);
      return NULL;
    }

  /* RECUPERATION DES INFORMATIONS DU FICHIER */
  fstat(stream->desc,&st);

  /* LA TAILLE */
  if (stream->mode == 'r') stream->taille = st.st_size;
  else stream->taille = st.st_size + MYBUFSIZ;

  stream->pos = 0;

  /* ALLOCATION DE LA MEMOIRE */
  stream->buffer = (char*) malloc(stream->taille) ;
  if (stream->buffer == NULL) return NULL;

  return stream;
}
