#include "mystdio.h"

int myfread(MYFILE *stream, int n, int taille, void *tampon)
{
  int lec = n * taille;

  if (stream->mode == 'w')
    {
      fprintf(stderr,"Mode d'acces Incompatible!!!\n");
      return -1;
    }

  if (lec == 0)
    {
      fprintf(stderr,"ERREUR: Nombre ou Taille vide !!!\n");
      exit(-1);
    }

  if (stream->pos == 0)
    {
      fprintf(stderr,"Possition Null!\n");
      return -1;
    }

  if (read(stream->desc, stream->buffer, stream->taille) == -1)
    {
      fprintf(stderr,"Echec lors du chergement du fichier !\n");
      exit(-1);
    }

  tampon = stream->buffer;
  stream->pos++;

  return  stream->buffer[stream->taille + stream->pos -1 ];

}
