#ifndef MYSTDIOH
#define MYSTDIOH
#ifdef MYSTDIOC
#define EXTERN extern
#else
#define EXTERN
#endif /* MYSTDIOC */
#include <sys/types.h>

#define MYFILE		struct myfile
#define MYBUFSIZ	10

struct myfile {
  int	         d;
  unsigned char	 buf[MYBUFSIZ];
  off_t          bufoff;
  off_t          filoff;
  int            numchar;
  int	         flags;
#define OPEN_READ	1
#define OPEN_WRITE	2
#define OPEN_APPEND	4
  int            status;
#define CLEAN    0
#define DIRTY    1
#define UNLOADED 0
#define LOADED   2
#define ISCLEAN(s)  (((s)->status&DIRTY)==0)
#define ISDIRTY(s)  (((s)->status&DIRTY)!=0)
#define ISLOADED(s) (((s)->status&LOADED)!=0)
};

#if defined(__STDC__)
EXTERN MYFILE	*myfopen(const char *filename,const char *mode);
EXTERN int	myfputc(int c,MYFILE *stream);
EXTERN int	myfgetc(MYFILE *stream);
EXTERN int	myfflush(MYFILE *stream);
EXTERN int	myfclose(MYFILE *stream);
#endif

#endif /* MYSTDIOH */
