#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>

#define MYSEEK_SET 0
#define MYSEEK_CUR 1
#define MYSEEK_END 2

#define MYBUFSIZ 1024

struct _MYFILE {
  int desc;
  int flag;
  int taille;
  int pos;
  char mode;
  char *buffer;
};

typedef struct _MYFILE MYFILE;

MYFILE *myfopen(const char *filename, const char *mode);
int myfseek(MYFILE *stream, int position, int origine);
int myffluch(MYFILE *stream);
int myfread(MYFILE *stream, int n, int taille, void *tampon);
int myfwrite(MYFILE *stream, int n, int taille, void *tampon);
int myfclose(MYFILE *stream);

